window.addEventListener( 'load', function() {
  run();
});
var isShowRawValues;
var viewModel;
var component;
function run() {
  reset();
  // Må være space mellom alt og desimaltall skrives med .


  // if(true || !readRules()){
  if(!readRules()){
    // addSetOfRules("laaneutgifter = FETYPE.LOAN.INSTALLMENT.prop.amount");
  //   addRule("income", "FETYPE.INCOME");
  //   addRule("expenses", "FETYPE.EXPENSES");
  //   addRule("liquidity", "income - expenses");
  }

  var businessRules = buildRules();

  viewModel = new hd.PropertyModel();

  component = new hd.Component(businessRules);
  viewModel.addComponent(component);
  connectViewModelToHtmlView(component);
}

function connectViewModelToHtmlView(viewModel){
  getVariables().forEach((element, i) => {
    var row = getRow(element);
    var cell = row.insertCell(row.cells.length);
    var input = document.createElement("input");
    cell.appendChild(input);
    viewModel[element].set(getValue(element));
   twoWayDomBind(viewModel[element], input);
  });
}

function twoWayDomBind(modelv, input) {
  var obs = new hd.BasicObservable();
  obs.addObserver(modelv);
  input.addEventListener('input', () => {
    obs.sendNext(parseFloat(input.value));
});

  modelv.addObserver({
    onNext: (v) => {
    if (document.activeElement !== input){
      input.value = parseFloat(v).toFixed(2);
    }
  },
  onError: () => {},  onCompleted: () => {}});}

function getRow(type){
  var row = document.getElementById(type);
  if(!row){
    var table = document.getElementById("fintable");
    row = table.insertRow(table.rows.length);
    var cell = row.insertCell(row.cells.length);
    cell.innerHTML = getDescription(type);
  }
  if(!getParameterByName("raw") && (getDescription(type).includes("-") || getDescription(type).includes("PROP"))){
    row.style.visibility = "hidden";
  }
  return row;
}

function reset(){
    console.log("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
    if(viewModel){
    viewModel.removeComponent(component);
  }
  resetRules();
  var node = document.getElementById("fintable");
  while (node.firstChild) {
    node.removeChild(node.firstChild);
  }
}

function getParameterByName(name) {
  try {
    var url = window.location.href;
    var name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
      results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
  } catch (e){
    return false;
  }
}