var getTerminbelop = function(value, duration, nominalInterestRate, instalmentFee) {
}

getTerminbelop = function(FETYPE.LOAN.INSTALLMENT.prop.value, FETYPE.LOAN.INSTALLMENT.prop.durationMonths, FETYPE.LOAN.INSTALLMENT.prop.nominalInterestRate, FETYPE.LOAN.INSTALLMENT.prop.instalmentFee) {
    var amountThreshold = 100;
    var iterationLimit = 100;

    var calculate = function(value, duration, amount, nominalInterestRate, instalmentFee){
        var monthlyInterestRate = nominalInterestRate / 1200;
        var month = 1;
        var finished = function(value){
            return (value < 0 && Math.abs(value) < amountThreshold) || (value > 0 && value < amountThreshold);
        };
        var interest;
        var principal;
        while (month <= duration) {
            interest = value * monthlyInterestRate;
            principal = amount - interest - instalmentFee;
            value -= principal;
            if (finished(value)) {
                return amount;
            }
            if(value < 0){
                return -1;
            }
            month++;
        }
        return 0;
    };

    var interpolation = function(value, duration, nominalInterestRate, instalmentFee){
        var amount = 0;
        var lowest = value / duration;
        var highest = value * 0.5 *(duration/12);
        var iteration = 0;
        var pivotAmount;
        var result;
        while(amount === 0 && iteration < iterationLimit){
            pivotAmount = (highest + lowest) / 2;
            result = calculate(value, duration, pivotAmount, nominalInterestRate, instalmentFee);
            if(result === 0){
                lowest = pivotAmount;
            } else if (result === -1){
                highest = pivotAmount;
            } else {
                return result;
            }

            iteration++;
        }
    };

    return interpolation(value, durationMonths, nominalInterestRate, instalmentFee);
};
var y = getTerminbelop(1000000, 240, 3, 50);
alert(y);